data {
    int N;
    int M;
    int K;
    int<lower = 1, upper = K> X[N, M];
    vector[K-2] a;
}
transformed data {
    real C1;
    real CK_1;
    C1 = -1;
    CK_1 = 1;
}
parameters {
    real mu[M];
    real<lower = 0.0> Lmd[M];
    real<lower = 0.0> psy[M];
    simplex[K-2] Ck; 
    real F[N];
}
transformed parameters {
    vector[K] p[N, M];
    vector[K-1] cumP[N, M];
    real C[K-1];
    C[1] = C1;
    C[K-1] = CK_1;
    for (k in 1:(K-3)) {
        C[k+1] = C[k] + Ck[k] * 2.0;
    }
    for (i in 1:N)
        for (j in 1:M){
            cumP[i][j][K-1] = normal_cdf((C[K-1] - (mu[j] + Lmd[j] * F[i])) / psy[j], 0.0, 1.0);
            cumP[i][j][1] = normal_cdf((C[1] - (mu[j] + Lmd[j] * F[i])) / psy[j], 0.0, 1.0);
            for (k in 1:(K-3)) {
                cumP[i][j][k+1] = normal_cdf((C[k+1] - (mu[j] + Lmd[j] * F[i])) / psy[j], 0.0, 1.0);
            }
            p[i][j][1] = cumP[i][j][1];
            for (k in 1:(K-2)) {
                p[i][j][k+1] = cumP[i][j][k+1] - cumP[i][j][k]; 
            }
            p[i][j][K] = 1.0 - cumP[i][j][K-1];
        }
    
}
model {
    for (j in 1:M) {
        mu[j] ~ normal(0.0, 100.0);
        psy[j] ~ exponential(0.01);
        Lmd[j] ~ exponential(0.01);
    }
    Ck ~ dirichlet(a);
    for (i in 1:N) {
        F[i] ~ normal(0.0, 1.0);
    }
    for (i in 1:N) {
        for (j in 1:M) {
            X[i][j] ~ categorical(p[i][j]);
        }
    }
}
